;; | ----------------------------------------------------------------------------
;; | C:3df2pl
;; | ----------------------------------------------------------------------------
;; | Function : Convert 3DFACEs to normal 3d polylines.
;; | Author   : (C) Rakesh Rao, Singapore
;; | Action   : --
;; | Updated  : April 21, 1999
;; | ----------------------------------------------------------------------------
(defun c:3df2pl ( / ss ename entl cnt OS )
(setvar "CMDECHO" 0)
(princ "\nConverts 3DFACE to a 3D Polyline with elevations of each 3DFACE vertex.")
(setq ss (ssget (list (cons 0 "3DFACE"))))
(if ss
(progn
    (setq
        OS  (getvar "OSMODE")
        ssl (sslength ss)
        cnt 0
    )
    (setvar "OSMODE" 0)
    (princ "\n")
    (repeat ssl
        (setq
            ename (ssname ss cnt)
            entl  (entget ename)
            cnt   (1+ cnt)
        )
        (command "._3dpoly" (LI_item 10 entl) (LI_item 11 entl) (LI_item 12 entl) (LI_item 13 entl) "_Close")
    )
    (setvar "OSMODE" OS)
))
(prin1)
)
;; | ---------------------------------------------------------------------------
;; | LI_item
;; | ---------------------------------------------------------------------------
;; | Function : Returns the first occurence of a DXF dotted pair from a list
;; | Argument : 'n'     - The DXF code to check
;; |            'alist' - The List to check
;; | Returns  : The value of the DXF dotted pair, if it exists else returns nil
;; | Update   : December 26, 1998
;; | e-mail   : rakesh.rao@4d-technologies.com
;; | Web      : www.4d-technologies.com
;; | ---------------------------------------------------------------------------
(defun LI_item (n alist)
    (cdr (assoc n alist))
)
(princ "\nType '3df2pl' to start.")
(prin1)